* --------------------------------------------------------------------------- *
*					 un mandel-boot !!! (avec 9 exemples) *
*						       ecrit par FLASHER JACK *
* --------------------------------------------------------------------------- *

* ---------------------------------------------------------------- constantes *
location		equ	$30000

* ------------------------------------------------------- localisation du prg *
			jmp	location
			org	location
			load	location

* ------------------------------------------------- commandes macro assembler *
videpic			macro
			lea.l	\1,a0
vide\@			clr.l	(a0)+
			cmp.l	#\2,a0
			bls.b	vide\@
			endm

* -------------------------------------------------------------- debut du prg *
debut			dc.b	"DOS",0			* a retirer pour
			dc.l	0,880			* executer

			movem.l	d0-a6,-(a7)
			lea.l	debut(pc),a3
			lea.l	$dff002,a6
			videpic	$40000,$70000

			lea.l	$40000+40,a0
			lea.l	image-debut(a3),a2
			moveq.l	#5-1,d7
copy			move.w	(a2)+,(a0)+
			move.w	(a2)+,(a0)+
			move.w	(a2)+,(a0)
			lea.l	40-4(a0),a0
			dbf	d7,copy

			bsr.w	aff_mand

			lea.l	table-debut(a3),a0
			move.l	(a0)+,xiter2-debut(a3)
			move.l	(a0)+,yiter2-debut(a3)
			move.l	(a0)+,xpos-debut(a3)
			move.l	(a0),ypos-debut(a3)

			move.w	(a6),d0
			or.w	d0,sauve_dma+2-debut(a3)

			lea.l	copper-debut(a3),a0
			move.l	a0,$80-2(a6)
			lea.l	mandelbroot-debut(a3),a0
			move.l	a0,$80.w
			trap	#0
			movem.l	(a7)+,d0-a6

* --------------------------------------------------------------- le resident *
			lea.l	dosname(pc),a1
			jsr	-96(a6)
			move.l	d0,a0
			move.l	22(a0),a0
			moveq.l	#0,d0
			rts

* -------------------------------------------- generateur de mandelbroot v1.2 *
* -------------- pas tres rapide mais je m'en fout!!! (c'etait juste 1 essai) *
mandelbroot		sub.l	a0,a0
			move.l	ypos-debut(a3),d6
			move.l	xpos-debut(a3),d7
calcy			btst.b	#6,$bfe001
			beq.w	retour
			sub.l	a1,a1
calcx			sub.l	a2,a2
init			moveq.l	#0,d0
			moveq.l	#0,d1
			moveq.l	#0,d2
			moveq.l	#0,d3
			moveq.l	#0,d4
calc			move.l	#$7ffff,d5		* niveau
			muls.w	d0,d1
			asr.l	#4,d1
			asr.l	#5,d1
			sub.l	d7,d1
			move.l	d2,d0
			sub.l	d3,d0			* -
			sub.l	d6,d0
			move.l	d0,d2
			move.l	d1,d3
			muls.w	d2,d2
			muls.w	d3,d3
			asr.l	#5,d2			* /32
			asr.l	#5,d2
			asr.l	#5,d3
			asr.l	#5,d3
			addq.b	#1,d4			* compteur des points
			cmp.b	#32,d4			* 32 points/block
			bge.b	ecr2
			sub.l	d3,d5
			sub.l	d2,d5
			bge.b	calc
			bra.b	place
ecr2			clr.w	d4			* debut du block
place			lea.l	$50000,a4		* les 5 plans
			move.l	(a4)+,a5		* place les points
			asr.w	#1,d4			* a la 68000
			roxl.w	(a5)
			move.l	(a4)+,a5
			asr.w	#1,d4
			roxl.w	(a5)
			move.l	(a4)+,a5
			asr.w	#1,d4
			roxl.w	(a5)
			move.l	(a4)+,a5
			asr.w	#1,d4
			roxl.w	(a5)
			move.l	(a4),a5
			asr.w	#1,d4
			roxl.w	(a5)
			add.l	xiter2-debut(a3),d6
			addq.l	#1,a2
			cmp.l	#15,a2			* points/block
			ble.b	init
			lea.l	$50000,a4
			addq.l	#2,(a4)+
			addq.l	#2,(a4)+
			addq.l	#2,(a4)+
			addq.l	#2,(a4)+
			addq.l	#2,(a4)
			addq.l	#1,a1
			cmp.l	#19,a1			* blocks (20 mots)
			ble.w	calcx
			move.l	ypos-debut(a3),d6
			sub.l	yiter2-debut(a3),d7
			addq.l	#1,a0
			cmp.l	#255,a0			* lignes
			ble.w	calcy
			lea.l	table-debut(a3),a0
			add.w	pos_table-debut(a3),a0
			cmp.l	#-1,(a0)
			bne.b	fin_table
			clr.w	pos_table-debut(a3)
			lea.l	table(pc),a0
fin_table		move.l	(a0)+,xiter2-debut(a3)
			move.l	(a0)+,yiter2-debut(a3)
			move.l	(a0)+,xpos-debut(a3)
			move.l	(a0),ypos-debut(a3)
			add.w	#16,pos_table-debut(a3)
			bsr.b	aff_mand		* la 2eme
			bra.w	mandelbroot		* page fiston!!

* ----------------------------------------------------------------- le retour *
retour
sauve_dma		move.w	#$8000,$96-2(a6)
			move.l	4.w,a5
			move.l	156(a5),a5
			move.l	38(a5),$80-2(a6)
 			rte
 
* ---------------------------------------------- place les plans ds la copper *
aff_mand		lea.l	$50000,a1
			move.l	#$60000,d0
			lea.l	mandelbp1+2-debut(a3),a0
			moveq.l	#5-1,d7
copy_bps		move.w	d0,4(a0)
			swap.w	d0
			move.w	d0,(a0)
			swap.w	d0
			move.l	d0,(a1)+
			lea.l	8(a0),a0
			add.l	#(256*40),d0
			dbf	d7,copy_bps
			rts

* ----------------------------------------------------------------- variables *
dosname			dc.b	"dos.library",0
pos_table		dc.w	16
table			dc.l	14,14,1000,-2024	* les exemples
			dc.l	12,8,1000,-1024
			dc.l	8,4,1000,-1024
			dc.l	8,8,0,-1024
			dc.l	8,14,2000,-1024
			dc.l	8,4,2000,-1024
			dc.l	-24,-24,-1000,2000
			dc.l	44,44,1000,-2024
			dc.l	2,2,500,1024
			dc.l	-1
xpos			dc.l	0
ypos			dc.l	0
xiter2			dc.l	0
yiter2			dc.l	0
copper			dc.w	$8e,$2081,$90,$2ac1
			dc.w	$92,$38,$94,$d0
			dc.w	$96,$20,$96,$87c0	* ha! l'astuce!
			dc.w	$140,0
			dc.w	$100,$5200
			dc.w	$102,0,$104,0
			dc.w	$108,0,$10a,0
mandelbp1		dc.w	$e0,0,$e2,0
mandelbp2		dc.w	$e4,0,$e6,0
mandelbp3		dc.w	$e8,0,$ea,0
mandelbp4		dc.w	$ec,0,$ee,0
mandelbp5		dc.w	$f0,0,$f2,0
			dc.w	$180,0,$182,$f0d,$184,$f0b,$186,$f09
			dc.w	$188,$f07,$18a,$f05,$18c,$f03,$18e,$f01
			dc.w	$190,$f10,$192,$f30,$194,$f50,$196,$f70
			dc.w	$198,$f90,$19a,$fb0,$19c,$fd0,$19e,$ff0
			dc.w	$1a0,$ff1,$1a2,$ff3,$1a4,$ff5,$1a6,$ff7
			dc.w	$1a8,$ff9,$1aa,$ffb,$1ac,$ffd,$1ae,$fff
			dc.w	$1b0,$ddd,$1b2,$bbb,$1b4,$aaa,$1b6,$999
			dc.w	$1b8,$777,$1ba,$555,$1bc,$333,$1be,$111
			dc.w	-33,-2
			dc.w	$2009,-2
			dc.w	$e0,4,$e2,0
			dc.w	$100,$1200
			dc.w	$182,$444
			dc.l	-2
image			dc.w	%1110101110111000,%0011101010101100,%0000111011101010
			dc.w	%1000101000100000,%1010001010101010,%0000101010101010
			dc.w	%1100101110100001,%0011101100101010,%1110110010101010
			dc.w	%1000100010100010,%0000101010101010,%0000101010101110
			dc.w	%1000101110111000,%0011101010101100,%0000101011101010
			dc.b	"CODED BY FLASHER JACK",0
fin			end
